package alinlp

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// GetOpenStatusOfServiceCenter invokes the alinlp.GetOpenStatusOfServiceCenter API synchronously
func (client *Client) GetOpenStatusOfServiceCenter(request *GetOpenStatusOfServiceCenterRequest) (response *GetOpenStatusOfServiceCenterResponse, err error) {
	response = CreateGetOpenStatusOfServiceCenterResponse()
	err = client.DoAction(request, response)
	return
}

// GetOpenStatusOfServiceCenterWithChan invokes the alinlp.GetOpenStatusOfServiceCenter API asynchronously
func (client *Client) GetOpenStatusOfServiceCenterWithChan(request *GetOpenStatusOfServiceCenterRequest) (<-chan *GetOpenStatusOfServiceCenterResponse, <-chan error) {
	responseChan := make(chan *GetOpenStatusOfServiceCenterResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.GetOpenStatusOfServiceCenter(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// GetOpenStatusOfServiceCenterWithCallback invokes the alinlp.GetOpenStatusOfServiceCenter API asynchronously
func (client *Client) GetOpenStatusOfServiceCenterWithCallback(request *GetOpenStatusOfServiceCenterRequest, callback func(response *GetOpenStatusOfServiceCenterResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *GetOpenStatusOfServiceCenterResponse
		var err error
		defer close(result)
		response, err = client.GetOpenStatusOfServiceCenter(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// GetOpenStatusOfServiceCenterRequest is the request struct for api GetOpenStatusOfServiceCenter
type GetOpenStatusOfServiceCenterRequest struct {
	*requests.RpcRequest
	OneLevelCategoryName string `position:"Body" name:"OneLevelCategoryName"`
	ServiceCode          string `position:"Body" name:"ServiceCode"`
	TwoLevelCategoryName string `position:"Body" name:"TwoLevelCategoryName"`
}

// GetOpenStatusOfServiceCenterResponse is the response struct for api GetOpenStatusOfServiceCenter
type GetOpenStatusOfServiceCenterResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	Data      string `json:"Data" xml:"Data"`
}

// CreateGetOpenStatusOfServiceCenterRequest creates a request to invoke GetOpenStatusOfServiceCenter API
func CreateGetOpenStatusOfServiceCenterRequest() (request *GetOpenStatusOfServiceCenterRequest) {
	request = &GetOpenStatusOfServiceCenterRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("alinlp", "2020-06-29", "GetOpenStatusOfServiceCenter", "alinlp", "openAPI")
	request.Method = requests.POST
	return
}

// CreateGetOpenStatusOfServiceCenterResponse creates a response to parse from GetOpenStatusOfServiceCenter response
func CreateGetOpenStatusOfServiceCenterResponse() (response *GetOpenStatusOfServiceCenterResponse) {
	response = &GetOpenStatusOfServiceCenterResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
