package alinlp

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ListOneLevelCategory invokes the alinlp.ListOneLevelCategory API synchronously
func (client *Client) ListOneLevelCategory(request *ListOneLevelCategoryRequest) (response *ListOneLevelCategoryResponse, err error) {
	response = CreateListOneLevelCategoryResponse()
	err = client.DoAction(request, response)
	return
}

// ListOneLevelCategoryWithChan invokes the alinlp.ListOneLevelCategory API asynchronously
func (client *Client) ListOneLevelCategoryWithChan(request *ListOneLevelCategoryRequest) (<-chan *ListOneLevelCategoryResponse, <-chan error) {
	responseChan := make(chan *ListOneLevelCategoryResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ListOneLevelCategory(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ListOneLevelCategoryWithCallback invokes the alinlp.ListOneLevelCategory API asynchronously
func (client *Client) ListOneLevelCategoryWithCallback(request *ListOneLevelCategoryRequest, callback func(response *ListOneLevelCategoryResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ListOneLevelCategoryResponse
		var err error
		defer close(result)
		response, err = client.ListOneLevelCategory(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ListOneLevelCategoryRequest is the request struct for api ListOneLevelCategory
type ListOneLevelCategoryRequest struct {
	*requests.RpcRequest
	ServiceCode string `position:"Body" name:"ServiceCode"`
}

// ListOneLevelCategoryResponse is the response struct for api ListOneLevelCategory
type ListOneLevelCategoryResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	Data      string `json:"Data" xml:"Data"`
}

// CreateListOneLevelCategoryRequest creates a request to invoke ListOneLevelCategory API
func CreateListOneLevelCategoryRequest() (request *ListOneLevelCategoryRequest) {
	request = &ListOneLevelCategoryRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("alinlp", "2020-06-29", "ListOneLevelCategory", "alinlp", "openAPI")
	request.Method = requests.POST
	return
}

// CreateListOneLevelCategoryResponse creates a response to parse from ListOneLevelCategory response
func CreateListOneLevelCategoryResponse() (response *ListOneLevelCategoryResponse) {
	response = &ListOneLevelCategoryResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
