package alinlp

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ListServiceInfoOfServiceCenter invokes the alinlp.ListServiceInfoOfServiceCenter API synchronously
func (client *Client) ListServiceInfoOfServiceCenter(request *ListServiceInfoOfServiceCenterRequest) (response *ListServiceInfoOfServiceCenterResponse, err error) {
	response = CreateListServiceInfoOfServiceCenterResponse()
	err = client.DoAction(request, response)
	return
}

// ListServiceInfoOfServiceCenterWithChan invokes the alinlp.ListServiceInfoOfServiceCenter API asynchronously
func (client *Client) ListServiceInfoOfServiceCenterWithChan(request *ListServiceInfoOfServiceCenterRequest) (<-chan *ListServiceInfoOfServiceCenterResponse, <-chan error) {
	responseChan := make(chan *ListServiceInfoOfServiceCenterResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ListServiceInfoOfServiceCenter(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ListServiceInfoOfServiceCenterWithCallback invokes the alinlp.ListServiceInfoOfServiceCenter API asynchronously
func (client *Client) ListServiceInfoOfServiceCenterWithCallback(request *ListServiceInfoOfServiceCenterRequest, callback func(response *ListServiceInfoOfServiceCenterResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ListServiceInfoOfServiceCenterResponse
		var err error
		defer close(result)
		response, err = client.ListServiceInfoOfServiceCenter(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ListServiceInfoOfServiceCenterRequest is the request struct for api ListServiceInfoOfServiceCenter
type ListServiceInfoOfServiceCenterRequest struct {
	*requests.RpcRequest
	ServiceCode         string `position:"Body" name:"ServiceCode"`
	OneLeveCategoryName string `position:"Body" name:"OneLeveCategoryName"`
	TwoLeveCategoryName string `position:"Body" name:"TwoLeveCategoryName"`
}

// ListServiceInfoOfServiceCenterResponse is the response struct for api ListServiceInfoOfServiceCenter
type ListServiceInfoOfServiceCenterResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	Data      string `json:"Data" xml:"Data"`
}

// CreateListServiceInfoOfServiceCenterRequest creates a request to invoke ListServiceInfoOfServiceCenter API
func CreateListServiceInfoOfServiceCenterRequest() (request *ListServiceInfoOfServiceCenterRequest) {
	request = &ListServiceInfoOfServiceCenterRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("alinlp", "2020-06-29", "ListServiceInfoOfServiceCenter", "alinlp", "openAPI")
	request.Method = requests.POST
	return
}

// CreateListServiceInfoOfServiceCenterResponse creates a response to parse from ListServiceInfoOfServiceCenter response
func CreateListServiceInfoOfServiceCenterResponse() (response *ListServiceInfoOfServiceCenterResponse) {
	response = &ListServiceInfoOfServiceCenterResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
