package alinlp

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ListVersionServiceApi invokes the alinlp.ListVersionServiceApi API synchronously
func (client *Client) ListVersionServiceApi(request *ListVersionServiceApiRequest) (response *ListVersionServiceApiResponse, err error) {
	response = CreateListVersionServiceApiResponse()
	err = client.DoAction(request, response)
	return
}

// ListVersionServiceApiWithChan invokes the alinlp.ListVersionServiceApi API asynchronously
func (client *Client) ListVersionServiceApiWithChan(request *ListVersionServiceApiRequest) (<-chan *ListVersionServiceApiResponse, <-chan error) {
	responseChan := make(chan *ListVersionServiceApiResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ListVersionServiceApi(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ListVersionServiceApiWithCallback invokes the alinlp.ListVersionServiceApi API asynchronously
func (client *Client) ListVersionServiceApiWithCallback(request *ListVersionServiceApiRequest, callback func(response *ListVersionServiceApiResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ListVersionServiceApiResponse
		var err error
		defer close(result)
		response, err = client.ListVersionServiceApi(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ListVersionServiceApiRequest is the request struct for api ListVersionServiceApi
type ListVersionServiceApiRequest struct {
	*requests.RpcRequest
	ServiceCode string `position:"Body" name:"ServiceCode"`
}

// ListVersionServiceApiResponse is the response struct for api ListVersionServiceApi
type ListVersionServiceApiResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	Data      string `json:"Data" xml:"Data"`
}

// CreateListVersionServiceApiRequest creates a request to invoke ListVersionServiceApi API
func CreateListVersionServiceApiRequest() (request *ListVersionServiceApiRequest) {
	request = &ListVersionServiceApiRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("alinlp", "2020-06-29", "ListVersionServiceApi", "alinlp", "openAPI")
	request.Method = requests.POST
	return
}

// CreateListVersionServiceApiResponse creates a response to parse from ListVersionServiceApi response
func CreateListVersionServiceApiResponse() (response *ListVersionServiceApiResponse) {
	response = &ListVersionServiceApiResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
