package alinlp

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// OverViewPageConfigInfo invokes the alinlp.OverViewPageConfigInfo API synchronously
func (client *Client) OverViewPageConfigInfo(request *OverViewPageConfigInfoRequest) (response *OverViewPageConfigInfoResponse, err error) {
	response = CreateOverViewPageConfigInfoResponse()
	err = client.DoAction(request, response)
	return
}

// OverViewPageConfigInfoWithChan invokes the alinlp.OverViewPageConfigInfo API asynchronously
func (client *Client) OverViewPageConfigInfoWithChan(request *OverViewPageConfigInfoRequest) (<-chan *OverViewPageConfigInfoResponse, <-chan error) {
	responseChan := make(chan *OverViewPageConfigInfoResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.OverViewPageConfigInfo(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// OverViewPageConfigInfoWithCallback invokes the alinlp.OverViewPageConfigInfo API asynchronously
func (client *Client) OverViewPageConfigInfoWithCallback(request *OverViewPageConfigInfoRequest, callback func(response *OverViewPageConfigInfoResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *OverViewPageConfigInfoResponse
		var err error
		defer close(result)
		response, err = client.OverViewPageConfigInfo(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// OverViewPageConfigInfoRequest is the request struct for api OverViewPageConfigInfo
type OverViewPageConfigInfoRequest struct {
	*requests.RpcRequest
	ServiceCode string `position:"Body" name:"ServiceCode"`
}

// OverViewPageConfigInfoResponse is the response struct for api OverViewPageConfigInfo
type OverViewPageConfigInfoResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	Data      string `json:"Data" xml:"Data"`
}

// CreateOverViewPageConfigInfoRequest creates a request to invoke OverViewPageConfigInfo API
func CreateOverViewPageConfigInfoRequest() (request *OverViewPageConfigInfoRequest) {
	request = &OverViewPageConfigInfoRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("alinlp", "2020-06-29", "OverViewPageConfigInfo", "alinlp", "openAPI")
	request.Method = requests.POST
	return
}

// CreateOverViewPageConfigInfoResponse creates a response to parse from OverViewPageConfigInfo response
func CreateOverViewPageConfigInfoResponse() (response *OverViewPageConfigInfoResponse) {
	response = &OverViewPageConfigInfoResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
